#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>
#include <stdio.h>

int
main (void)
{
  key_t mykey;
  int shmid;
  char *testch = NULL;

  mykey = IPC_PRIVATE;

  printf ("creating private key... ");
  shmid = shmget (mykey, 65536, 0777);
  if (shmid != -1)
    {
      printf ("id %x\n", shmid);
      printf ("attaching... ");
      testch = (char *) shmat (shmid, NULL, 0);
      if (testch == (char *) -1)
	{
	  printf ("error %d, %s\n", errno, strerror (errno));
	  /* todo: delete the shm area */
	  return 1;
	}
      printf ("mapped to %x\n", testch);
      printf ("writing \'hello\' ...\n");
      snprintf (testch, 6, "hello");
      printf ("reading ... ");
      printf ("'%s'\n", testch);
    }
  else
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  return 0;
}
